<!DOCTYPE html>
<html>

	<head>

		<title>Assets Managment System</title>

		<link rel="icon" href="/Images/APG-Assets-Favicon.png" type="image/png" sizes="32x32">
		<link rel="stylesheet" href="/CSS/main.css">
		<link rel="stylesheet" href="/CSS/sidebar.css">
		<link rel="stylesheet" href="/CSS/addnew.css">
		<link rel="stylesheet" href="/CSS/viewTable.css">
		<link rel="stylesheet" href="/CSS/table.css">
		<link rel="stylesheet" href="/CSS/popups.css">
		<link rel="stylesheet" href="/CSS/form.css">

		<link rel="stylesheet" href="https://cdn.datatables.net/1.11.3/css/jquery.dataTables.min.css">

		<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
		
		<link href="https://fonts.googleapis.com/icon?family=Material+Icons+Outlined" rel="stylesheet">
		
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>

		<script src="https://cdn.datatables.net/1.11.3/js/jquery.dataTables.min.js"></script>

		<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment-with-locales.min.js" integrity="sha512-LGXaggshOkD/at6PFNcp2V2unf9LzFq6LE+sChH7ceMTDP0g2kn6Vxwgg7wkPP7AAtX+lmPqPdxB47A0Nz0cMQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
	
	</head>
		
	<meta charset="UTF-8">
		
	<body class="all_content" style="margin-top: 90px;   display: flex; align-items: flex-start;">
		<!-- // Header Functions Etc // -->
		
		<?php

			include '../../Func/main.php';

			HeaderMain();

			include '../../Func/reports.php';

		?>

		<script>
			$(document).ready( function () {

				$('#table_class').DataTable({
					"scrollX": true,
					"scrollY": "calc(50vh - 300px)",
					"paging":   false,
					"order": [[ 0, "desc" ]],
					"responsive": true,
					
				});


			});

		</script>

		<script>
			
			reportScript();

			DateLimits();

			function DateLimits(){

				document.getElementById("endDate").setAttribute("min", "1970-01-01");
				document.getElementById("endDate").setAttribute("max", "2121-12-31");
				document.getElementById("startDate").setAttribute("min", "1970-01-01");
				document.getElementById("startDate").setAttribute("max", "2121-12-31");

			}

			function reportScript() {

				// INPUT DATES
				var startd		= document.getElementById("startDate").value;
				var endd		= document.getElementById("endDate").value;


				// SET INPUT LIMITS 
				document.getElementById("startDate").setAttribute("max", endd);
				document.getElementById("endDate").setAttribute("min", startd);


				// GET AND RESET
				var ReportsTable	= document.getElementById("table_class");
				var tbodyRowCount 	= ReportsTable.tBodies[0].rows.length;
				var SumValAfter 	= 0.00;
				var compDepr		= 0.00;



				// DECLARE SUMS 

				var
				CostSARSum			= 0.00,
				CostFullWCompSum	= 0.00,
				DeprAnnualSum		= 0.00,
				DeprMonthlySum		= 0.00,
				DeprDailySum		= 0.00,
				DeprAmmtSum			= 0.00,
				DeprValSum			= 0.00,
				AccumilativeSum		= 0.00,
				compCostSumSum		= 0.00,
				compDeprAmmtSumSum	= 0.00;


				var i = 0;
				do {
					i += 1;

					// COLLECT DATA

					var purch 		= ReportsTable.rows[i].cells[6].innerHTML;
					var exp 		= ReportsTable.rows[i].cells[7].innerHTML;
					var rval 		= ReportsTable.rows[i].cells[8].innerHTML;
					var currency 	= ReportsTable.rows[i].cells[9].innerHTML;
					var currRate 	= ReportsTable.rows[i].cells[10].innerHTML;
					var cost 		= ReportsTable.rows[i].cells[11].innerHTML;
					var compline	= ReportsTable.rows[i].cells[12].innerHTML;

					startDate 	= parseDate(purch);
					endDate 	= parseDate(endDate);
					
					// COMP DEPR
					var CompDeprValues = CompDeprCalculator(compline, i, endd);
					// daysDiff, costSum, deprAmmtSum, deprValSum, compdeprAnnual, compdeprMonthly, compdeprDaily
					var
					compDaysDiff 		= CompDeprValues[0],
					compCostSum			= CompDeprValues[1],
					compDeprAmmtSum 	= CompDeprValues[2],
					compDeprValSum 		= CompDeprValues[3],
					compdeprAnnual		= CompDeprValues[4], 
					compdeprMonthly		= CompDeprValues[5],
					compdeprDaily		= CompDeprValues[6];

					// debug
					// console.log('CompDeprCalculator exit');
					// console.log('compDaysDiff[' 	+ compDaysDiff 		+ ']');
					// console.log('compCostSum[' 		+ compCostSum 		+ ']');
					// console.log('compDeprAmmtSum[' 	+ compDeprAmmtSum 	+ ']');
					// console.log('compDeprValSum[' 	+ compDeprValSum 	+ ']');
					// console.log('-------------');
					
					

					//DEPR

					var DeprValues = DeprCalculator(purch, exp, endd, (cost*currRate), rval, compDeprValSum);
					// daysDiff, deprAnnual, deprMonthly, deprDaily, CostWComp, deprAmmt, deprVal

					var
					DaysDiff 		= DeprValues[0],
    				DeprAnnual 		= DeprValues[1],
    				DeprMonthly 	= DeprValues[2],
    				DeprDaily 		= DeprValues[3],
					CostFull		= DeprValues[4],
    				DeprAmmt 		= DeprValues[5],
    				DeprVal 		= DeprValues[6];

					// debug
					// console.log('DeprCalculator exit');
					// console.log('DaysDiff[' 	+ DaysDiff 		+ ']');
					// console.log('DeprAnnual[' 	+ DeprAnnual 	+ ']');
					// console.log('DeprMonthly[' 	+ DeprMonthly 	+ ']');
					// console.log('DeprDaily[' 	+ DeprDaily 	+ ']');
					// console.log('CostFull[' 	+ CostFull 		+ ']');
					// console.log('DeprAmmt[' 	+ DeprAmmt 		+ ']');
					// console.log('DeprVal[' 		+ DeprVal 		+ ']');
					// console.log('-------------');


					// NUMBER FORMAT //
					compCostSumSum 		+= Number(compCostSum);
					compDeprAmmtSumSum	+= Number(compDeprAmmtSum);

					compCostSum 	= compCostSum.toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					compDeprAmmtSum	= Number(compDeprAmmtSum).toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					
					if (CostFull == 0){
						CostFull = 1;
						CostFull = 0;
					} else {
						DeprPerYearPercent 	= ((DeprAnnual+compdeprAnnual)*100/(Number(cost*currRate)+Number(compCostSum))).toLocaleString('en-US', {maximumFractionDigits:2})+'%';
					}
					CostFullWComp = (Number(cost*currRate)+Number(compCostSum));
					var Accumilative = Number(DeprDaily+compdeprDaily) * DaysDiff;
					if (Accumilative <= 0){
						Accumilative < 0;
					} else if (Accumilative >= CostFullWComp){
						Accumilative = CostFullWComp;
					}
					//
					DaysDiff		= Number(DaysDiff);


					// Sums
					CostSARSum			+= (cost*currRate);
					CostFullWCompSum	+= CostFullWComp;
					DeprAnnualSum		+= (DeprAnnual + compdeprAnnual);
					DeprMonthlySum 		+= (DeprMonthly + compdeprMonthly);
					DeprDailySum		+= (DeprDaily + compdeprDaily);
					DeprAmmtSum 		+= DeprAmmt;
					DeprValSum			+= DeprVal;
					AccumilativeSum 	+= Accumilative;

					// Number Format
					var FullDayDiff	= FullDateDiff(purch, endd);
					CostSAR 		= (cost*currRate).toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					CostFullWComp 	= CostFullWComp.toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					DeprAnnual		= (DeprAnnual+compdeprAnnual).toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					DeprMonthly		= (DeprMonthly+compdeprMonthly).toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					DeprDaily		= (DeprDaily+compdeprDaily).toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					CostFull		= CostFull.toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					DeprAmmt		= DeprAmmt.toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					DeprVal			= DeprVal.toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});


					// REPLACE IN TABLE
					ReportsTable.rows[i].cells[13].innerHTML = compCostSum;
					ReportsTable.rows[i].cells[14].innerHTML = compDeprAmmtSum;

					ReportsTable.rows[i].cells[15].innerHTML = CostSAR;
					ReportsTable.rows[i].cells[16].innerHTML = CostFullWComp;
					ReportsTable.rows[i].cells[18].innerHTML = DeprVal;

					ReportsTable.rows[i].cells[19].innerHTML = DeprPerYearPercent;
					ReportsTable.rows[i].cells[20].innerHTML = FullDayDiff + '<br>or ' + DaysDiff + ' days';

					ReportsTable.rows[i].cells[21].innerHTML = DeprAnnual;
					ReportsTable.rows[i].cells[22].innerHTML = DeprMonthly;
					ReportsTable.rows[i].cells[23].innerHTML = DeprDaily;

					
					Accumilative = Accumilative.toLocaleString('en-US', {maximumFractionDigits:2, minimumFractionDigits:2});
					ReportsTable.rows[i].cells[17].innerHTML = Accumilative;



				} while ( i >= 1 && i < tbodyRowCount );
				document.getElementById("13").innerHTML = "Component Cost<br>SAR <span class='SumVals'>" + compCostSumSum.toLocaleString('en-US', 		{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;
				document.getElementById("14").innerHTML = "Purchase Cost<br>SAR <span class='SumVals'>" + compDeprAmmtSumSum.toLocaleString('en-US', 		{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;

				document.getElementById("15").innerHTML = "Purchase Cost<br>SAR <span class='SumVals'>" + CostSARSum.toLocaleString('en-US', 				{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;
				document.getElementById("16").innerHTML = "Full Purchase Cost<br>SAR <span class='SumVals'>" + CostFullWCompSum.toLocaleString('en-US', 	{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;
				document.getElementById("18").innerHTML = "NBV<br>SAR <span class='SumVals'>" + DeprValSum.toLocaleString('en-US', 						{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;

				document.getElementById("21").innerHTML = "Dep/yr<br>SAR <span class='SumVals'>" + DeprAnnualSum.toLocaleString('en-US', 					{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;
				document.getElementById("22").innerHTML = "Dep/month<br>SAR <span class='SumVals'>" + DeprMonthlySum.toLocaleString('en-US', 				{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;
				document.getElementById("23").innerHTML = "Dep/day<br>SAR <span class='SumVals'>" + DeprDailySum.toLocaleString('en-US', 					{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;

				document.getElementById("17").innerHTML = "Accumulated Depriciation<br>SAR <span class='SumVals'>" + AccumilativeSum.toLocaleString('en-US', 	{maximumFractionDigits:2, minimumFractionDigits:2}) + "</span>" ;
				
			}

			// DeprCalculator Function
			
			function DeprCalculator(purch, exp, enddate, cost, rval, compDeprVal){ // DONE

				var start		= parseDate(purch);
				var end			= parseDate(enddate);
				var exp			= parseDate(exp);
				
				var daysDiff 	= DaysDiff(end, start);
				var lifespan 	= DaysDiff(exp, start);

				if (daysDiff <= 0){
					daysDiff = 0;
				}
				if (lifespan <= 0){
					lifespan = 0;
				}


				var deprRate	= 1 / ( lifespan / 365.25 );

				var deprAnnual	= deprRate *  ( cost - rval );
				if (deprAnnual <= 0){
					deprAnnual = 0.00;
				}

				var deprMonthly = deprAnnual / 12;
				var deprDaily 	= deprAnnual / 365.25;

				var deprAmmt	= daysDiff * deprDaily;
				var CostWComp	= cost + compDeprVal;
				var deprVal		= CostWComp - deprAmmt;

				if (deprVal <= 0){
					deprVal = 0.00;
				}
				if (deprVal >= CostWComp){
					deprVal = CostWComp;
				}
				
				// debug
				// console.log('DeprCalculator');
				// console.log('days-set[' + daysDiff + ']');
				// console.log('depr-annual[' + deprAnnual + ']');
				// console.log('depr-Monthly[' + deprMonthly + ']');
				// console.log('depr-Daily[' + deprDaily + ']');
				// console.log('costWcomp[' + CostWComp + ']');
				// console.log('depr-ammt[' + deprAmmt + ']');
				// console.log('depr-val[' + deprVal + ']');
				// console.log('-------------');

				return [daysDiff, deprAnnual, deprMonthly, deprDaily, CostWComp, deprAmmt, deprVal];		// RETURN

			}

			function CompDeprCalculator(line, i, enddate){		// NEEDS WORK

				var daysDiff	= 0;

				var costSum 	= 0.00;
				var deprAmmtSum = 0.00;
				var deprValSum	= 0.00;

				var compdeprAnnual		= 0.00;
				var compdeprMonthly 	= 0.00;
				var compdeprDaily 		= 0.00;

				if (line == ''){
					return [daysDiff, costSum, deprAmmtSum, deprValSum, compdeprAnnual, compdeprMonthly, compdeprDaily];
				}

				var line = line+'';
				var split = line.split(';');
				var splitLen = split.length-1;

				i = 0;

				do {

					var values 		= split[i].split(',');

					var cost 		= values[0];
					var rval 		= values[1];
					var purchC 		= values[2];
					var expC 		= values[3];

					//
					var start		= parseDate(purchC);
					var exp			= parseDate(expC);
					var end			= parseDate(enddate);

					daysDiff 		= DaysDiff(end, start);
					var lifespan 	= DaysDiff(exp, start);

					if (daysDiff <= 0){
						daysDiff = 0;
					}

					if (lifespan <= 0){
						lifespan = 0;
					}


					var deprRate	= 1 / ( lifespan / 365.25 );

					compdeprAnnual	= deprRate *  ( cost - rval );
					if (compdeprAnnual <= 0){
						compdeprAnnual = 0.00;
					}
					
					compdeprMonthly = compdeprAnnual / 12;
					compdeprDaily 	= compdeprAnnual / 365.25;

					var deprAmmt	= daysDiff * compdeprDaily;
					var deprVal		= cost - deprAmmt;
					
					costSum 		+= Number(cost);
					deprAmmtSum 	+= Number(deprAmmt);
					deprValSum		+= Number(deprVal);

					i += 1;

				} while ( i >= 1 && i < splitLen );
				
				if (deprValSum <= 0){
					deprValSum = 0.00;
				}
				if (deprValSum >= costSum){
					deprValSum = costSum;
				}

				// debug
				// console.log('CompDeprCalculator');
				// console.log('daysDiff[' 	+ daysDiff 		+ ']');
				// console.log('costSum[' 		+ costSum 		+ ']');
				// console.log('deprAmmtSum[' 	+ deprAmmtSum 	+ ']');
				// console.log('deprValSum[' 	+ deprValSum 	+ ']');
				// console.log('-------------');

				return [daysDiff, costSum, deprAmmtSum, deprValSum, compdeprAnnual, compdeprMonthly, compdeprDaily];

			}

			function CompareAndChoose(first,second,pick){

				first 	= parseDate(first);
				second 	= parseDate(second);

				if (pick == 'smaller'){

					if (first < second) {
						var result = first;
					} else if (first > second) {
						var result = second;
					} else {
						var result = first;
						// equal 
					}

				} else if (pick == 'larger'){

					if (first < second) {
						var result = second;
					} else if (first > second) {
						var result = first;
					} else {
						var result = second;
						// equal
					}

				} else {
					// error
				}

				return result; // RETURN

			}

			//  //

			function DaysDiff(first, second) {

				// Take the difference between the dates and divide by milliseconds per day.
				// Round to nearest whole number to deal with DST.

				return ((first-second) / (1000*60*60*24)) ;

			}

			function YearsDiff(first, second){

				var days = DaysDiff(first, second);
				return Math.floor(days/365.25);

			}
			
			function FullDateDiff(first, second){

				var a = moment(second);
				var b = moment(first);

				var years = a.diff(b, 'year');
				b.add(years, 'years');

				var months = a.diff(b, 'months');
				b.add(months, 'months');

				var days = a.diff(b, 'days');

				var timeDiff = '';
				if (years > 0){
					timeDiff += years + ' y ';
				}
				if (months > 0){
					timeDiff += months + ' m ';
				}
				if (days > 0){
					timeDiff += days + ' d ';
				}
				if (timeDiff == ''){
					timeDiff = '0 d';
				}

				return(timeDiff);

			}
			
			function parseDate(str){

				str = str+'';
				var mdy = str.split('-');
				return new Date(mdy[0], mdy[1]-1, mdy[2]);

			}
			
			function parseCompDate(str){

				str = str+'';
				var ymd = str.split(',');
				return(ymd[0]);

			}
			
			function ParseSimple(date){

				return parseDate(date).toLocaleDateString("en-UK");

			}

		</script>

	</body>

</html>