<?php

	session_start();
	date_default_timezone_set('Asia/Riyadh');
	require "../../Func/database.php";
	$date = Date('Y-m-d');
	$datetime = Date('Y-m-d H:i:s');
	$sessionEmail = $_SESSION['email'];

	if ($_SESSION['loggedin'] == TRUE){

		if ($_SESSION['roles'] == "admin" || $_SESSION['roles'] == "finance"){
			// Filter Bar
			echo '<div class="reportsToolBar">';

			// echo "<input  class='input_box small_input' type='number' name='name' value='1' placeholder='placeholder' id='id' maxlength='32' onchange='reportScript();' >";
			echo '<span class="formtitle">Start Date</span>';
			DateTodayDefault("startDate", "Yes");

			echo '<span class="formtitle"><b>&#9679;</b> End Date</span>';
			DateTodayDefault("endDate", "No");

			echo '</div>';

			// SQL 
			$sql = 
			"SELECT assets.*, history.*, employees.firstName as fname, employees.lastName as lstname, employees.ai as ID, emp.* 
			FROM assets 
			JOIN history ON assets.assetTag = history.assetTag 
			JOIN employees ON employees.email = history.fromEmployee 
			JOIN employees AS emp ON emp.email = history.toEmployee 
			WHERE history.activeUser = 1
			ORDER BY `history`.`ai` DESC";

			$result = $con->query($sql);

			// Table
			echo
			"<table class='table_class' id='table_class'>
				<thead class='table_head'>
					<tr class='table_head_row'>

						<th class='h_cell'>Date Added 0</th>
						<th class='h_cell'>Category</th>
						<th class='h_cell'>Asset Tag</th>
						<th class='h_cell'>Make</th>
						<th class='h_cell'>Model</th>
						<th class='h_cell'>Assigned To </th>

						<th class='h_cell'>Purchase Date</th>
						<th class='h_cell'>End of Life Date</th>
						<th class='h_cell'>Residual Value/Disposal</th>
						<th class='h_cell'>Purchase Currency</th>
						<th class='h_cell' style='display:none;'>Rate</th>
						<th class='h_cell' >Purchase Cost</th>	

						<th class='h_cell'  style='display:none;'>Component Line</th>
						<th class='h_cell' >Component Cost</th>
						<th class='h_cell'  style='display:none;'>Component Depr</th>

						<th class='h_cell'>Purchase Cost SAR</th>
						<th class='h_cell'>Full Purchase Cost SAR</th>
						<th class='h_cell'>Accumulated Depriciation</th>

						<th class='h_cell'>NBV</th>
						<th class='h_cell'>Depreciation % / Year</th>
						<th class='h_cell'>Est Life</th>

						<th class='h_cell'>Dep/yr</th>
						<th class='h_cell'>Dep/month</th>
						<th class='h_cell'>Dep/day</th>

						<th class='h_cell' style='display:none;'>x</th>
						<th class='h_cell' style='display:none;'>x</th>
						<th class='h_cell' style='display:none;'>x</th>

						<th class='h_cell' style='display:none;'>x</th>
						<th class='h_cell' style='display:none;'>x</th>

					</tr>
				</thead>
			<tbody class='table_body'>";

			$rowNumber = 0;

			while($row = $result->fetch_assoc()){
				

				$dateAdded 		= $row['dateAdded'];
				$category		= $row['category'];
				$assetTag		= $row['assetTag'];
				$make			= $row['make'];
				$model			= $row['model'];
				$description	= $row['description'];
				$SN				= $row['SN'];
				$currency		= $row['currency'];
				$currRate		= $row['currRate'];
				$cost			= $row['cost'];
				$compCost		= $row['compCost'];
				$miscCost		= $row['miscCost'];
				$residualVal	= $row['residualVal'];
				$dateOfPurch	= $row['dateOfPurch'];
				$invoiceNum		= $row['invoiceNum'];
				$expYears		= $row['expYears'];
				$changedBy		= $row['changedBy'];
				$fromEmployee	= $row['fromEmployee'];
				$toEmployee		= $row['toEmployee'];
				$firstName		= $row['firstName'];
				$lastName		= $row['lastName'];
				$email			= $row['email'];
				$Dept_E			= $row['Dept_E'];

				

				$sqlcomp = "SELECT * FROM compCostList WHERE AssetTag_CL ='".$assetTag."' AND Delete_CL = 0 ORDER BY AI_CL DESC";
				$resultcomp = $con->query($sqlcomp);
				
				$costC = "";
				$residualValC = "";
				$expC = "";
				$purchC = "";
				$line = "";
				
				while($rowc = $resultcomp->fetch_assoc()) {
					
					// AI_CL	AssetTag_CL	DateAdded_CL	AddedBy_CL	CompCost_CL	Description_CL	CompPurchDate_CL	CompExpDate_CL	Delete_CL

					$costC = 			$rowc['CompCost_CL']; 
					$residualValC = 	$rowc['ResidualValue_CL']; 
					$purchC =			$rowc['CompPurchDate_CL']; 
					$expC = 			$rowc['CompExpDate_CL'];
					$line = $line.$costC.",".$residualValC.",".$purchC.",".$expC.";";


					// // annual depr
					// $deprRateC = 1 / ($daysExpToPurchC/365.2421);
					// $deprAnnualC = $deprRateC * ($costC - $residualValC);
	
					// // total depr to date
					// $deprToDateC = $deprToDateC + ($deprAnnualC/365.2421) * ($daysPurchToTodayC/365.2421);
					// $deprTotalC = $deprTotalC + ($costC-$deprToDateC);

				}


				echo "<tr class='table_body_row'>";

					echo "<td class='t_cell' style='white-space:nowrap;'>" . $dateAdded . "</td>";
					echo "<td class='t_cell'>" . $category . "</td>";
					echo "<td class='t_cell'><a class='anyLink' href='/View/?Tag=" . $assetTag . "'>".$assetTag."</a></td>";
					echo "<td class='t_cell'>" . $make . "</td>";
					echo "<td class='t_cell'>" . $model . "</td>";
					echo "<td class='t_cell'>" . $firstName . " " . $lastName . "<br>" . $email . "</td>";
					
					echo "<td class='t_cell' style='white-space: nowrap;'>" . $dateOfPurch . "</td>";
					echo "<td class='t_cell' style='white-space: nowrap;'>" . $expYears . "</td>";
					echo "<td class='t_cell' >" . $residualVal . "</td>";
					echo "<td class='t_cell' style='text-align: right !important;'>" . $currency . "</td>";
					echo "<td class='t_cell' style='display:none;'>" . $currRate . "</td>";
					echo "<td class='t_cell' style='text-align: left !important;'>" . $cost . "</td>";

					echo "<td class='t_cell'  style='display:none;'>" . $line . "</td>";
					echo "<td class='t_cell' >" . $compcost . "</td>";
					echo "<td class='t_cell'  style='display:none;'>" . $compdepr . "</td>";
					
					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";
					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";
					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";

					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";
					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";
					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";

					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";
					echo "<td class='t_cell' style='white-space:nowrap;'>" . $s . "</td>";
					echo "<td class='t_cell'>" . $s . "</td>";

					echo "<td class='t_cell' style='display:none;'>" . $s . "</td>";
					echo "<td class='t_cell' style='display:none;'>" . $s . "</td>";
					echo "<td class='t_cell' style='display:none;'>" . $s . "</td>";

					echo "<td class='t_cell' style='display:none;'>" . $s . "</td>";
					echo "<td class='t_cell' style='display:none;'>" . $s . "</td>";



				echo "</tr>";

			}

			echo 
			"</tbody>
				<tfoot class='table_foot'>
					<tr class='table_foot_row'>

						<th class='f_cell' >Date Added</th>
						<th class='f_cell' >Category</th>
						<th class='f_cell' >Asset Tag</th>
						<th class='f_cell' >Make</th>
						<th class='f_cell' >Model</th>
						<th class='f_cell' >Assigned To</th>

						<th class='f_cell' id='6' >Purchase Date</th>
						<th class='f_cell' id='6' >End of Life Date</th>
						<th class='f_cell' id='8' >Residual Value/Disposal</th>
						<th class='f_cell' id='9' >Purchase Currency</th>
						<th class='f_cell' id='10' style='display:none;'>Rate</th>
						<th class='f_cell' id='11'>Purchase Cost</th>

						<th class='f_cell' id='12' style='display:none;'>Component Line</th>
						<th class='f_cell' id='13' >Component Cost</th>
						<th class='f_cell' id='14' style='display:none;'>Component Depr</th>

						<th class='f_cell' id='15' >Purchase Cost</th>
						<th class='f_cell' id='16' >Full Purchase Cost SAR</th>
						<th class='f_cell' id='17' >Accumulated Depriciation</th>

						<th class='f_cell' id='18' >NBV</th>
						<th class='f_cell' id='19' >Depreciation % / Year</th>
						<th class='f_cell' id='20' >Est Life</th>

						<th class='f_cell' id='21' >Dep/yr</th>
						<th class='f_cell' id='22' >Dep/month</th>
						<th class='f_cell' id='23' >Dep/day</th>

						<th class='f_cell' style='display:none;' >x 24</th>
						<th class='f_cell' style='display:none;' >x 25</th>
						<th class='f_cell' style='display:none;' >x 26</th>
						
						<th class='f_cell' style='display:none;' >x 27</th>
						<th class='f_cell' style='display:none;' >x 28</th>

					</tr>
				</tfoot>
			</table>";

			// style='display:none;'

		} else {

			header("LOCATION: ../?MSG=notauthorized"); // PERMISSION

		}

	} else {

		header("LOCATION: ../Login/?MSG=notloggedin"); // LOGIN

	}

	// Script Loader
	function JSScript() {

		echo 
		'<script>
			function reportScript() {
				var myTable = document.getElementById("myTable");
				myTable.rows[0].cells[1].innerHTML = "Hello";
			}
		</script>';

	}

	function DateTodayDefault($name, $blank) {

		date_default_timezone_set('Asia/Riyadh');
	
		

		if ($blank == "Yes"){

			$Y = date('Y');
			$m = date('m');
			$d = date('d');

			$dateValue = $Y."-".$m."-".$d;

		} else {

			$Y = date('Y')+1;
			$m = date('m');
			$d = date('d');

			$dateValue = $Y."-".$m."-".$d;

		}

		echo 
		"<input class='input_date small_input' 
		style='width:150px !important;' 
		type='date'
		id='".$name."'
		name='".$name."'
		value='".$dateValue."'
		onchange='reportScript();' 
		required>";
	}

	


?>